Index: /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/cfg/X64_CURIE_cron.cfg
===================================================================
--- /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/cfg/X64_CURIE_cron.cfg	(revision 8825)
+++ /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/cfg/X64_CURIE_cron.cfg	(revision 8826)
@@ -5,8 +5,5 @@
 ## Default settings
 ##---------------------------------------------------
-TRUST_JOB_ENV=${TRUST_IO_XIOS}/arch/arch-${TRUST_MAIN_HPCC}.env
-
 TRUST_COMPILE_FORTRAN='ifort'
-
 TRUST_COMPILE_MPI='bullxmpi/'
 TRUST_COMPILE_NETCDF='netcdf-[0-9]'
@@ -14,14 +11,8 @@
 TRUST_IO_CDO='cdo'
 
-[ -z "${TRUST_COMPILE_NPROC}" ] && TRUST_COMPILE_NPROC='4'
-
-TRUST_JOB_SCRIPT=${TRUST_MAIN_DIR}/batch/${TRUST_MAIN_HPCC}.sh
-TRUST_JOB_SUBMIT="ccc_msub ${TRUST_JOB_SCRIPT} | grep -oe '\<[0-9]*\>'"
-
-TRUST_JOB_STATE="ccc_mpp   | grep \${TRUST_JOB_ID}"
+TRUST_JOB_SUBMIT="ccc_msub \${TRUST_JOB_SCRIPT} | grep -oe '\<[0-9]*\>'"
+TRUST_JOB_STATE="ccc_mpp  | grep \${TRUST_JOB_ID}"
 TRUST_JOB_INFO="ccc_macct        \${TRUST_JOB_ID}"
 TRUST_JOB_KILL="ccc_mdel         \${TRUST_JOB_ID}"
-
-[ -z "${TRUST_JOB_TIMEOUT}" ] && TRUST_JOB_TIMEOUT='10800'
 
 TRUST_JOB_TIME="
Index: /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/cfg/arch_template.cfg
===================================================================
--- /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/cfg/arch_template.cfg	(revision 8825)
+++ /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/cfg/arch_template.cfg	(revision 8826)
@@ -1,8 +1,18 @@
 ## (Super)Computer configuration template
-##---------------------------------------------------
+##--------------------------------------------------------------------------------
 
-## Copy to root, rename it and then fill in according to your (super)computer environment
-## Rules for completion: undefined variables (=) are mandatory & void variables (='') are optional
-## Look into other configuration file for examples
+## Copy/Rename it and fill in according to your environment.
+
+##  Rules for completion:
+##o Undefined variables (XXX=  ) are mandatory
+##o Empty     variables (XXX='') are optional, default value 
+
+## Look into other configuration file for examples.
+
+##  Most of the settings can be changed "on-the-fly" from the console to avoid
+##+ the creation of several configuration files.
+##+ See `./trusting.sh -h`
+
+##--------------------------------------------------------------------------------
 
 
@@ -10,5 +20,6 @@
 ##---------------------------------------------------
 # (Super)Computer environment (${TRUST_IO_XIOS} is already defined in the user configuration file)
-TRUST_JOB_ENV=${TRUST_IO_XIOS}/arch/arch-${TRUST_MAIN_HPCC}
+TRUST_JOB_ENV=''
+${TRUST_IO_XIOS}/arch/arch-${TRUST_MAIN_HPCC}
 ## If `module` is available, ${TRUST_JOB_ENV}.env will be sourced
 ## If not (scheduled jobs), it will be ${TRUST_JOB_ENV}.path or finally ${TRUST_JOB_ENV}
@@ -17,6 +28,6 @@
 ='cdo diffn'
 
-[ -z "${TRUST_COMPILE_NPROC}" ] && TRUST_COMPILE_NPROC=     ## Number of compiling processes
-[ -z "${TRUST_JOB_TIMEOUT}" ] && TRUST_JOB_TIMEOUT=     ## Timeout for computation (s)
+TRUST_COMPILE_NPROC=     ## Number of compiling processes
+TRUST_JOB_TIMEOUT=     ## Timeout for computation (s)
 
 
Index: /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/cfg/user_template.cfg
===================================================================
--- /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/cfg/user_template.cfg	(revision 8825)
+++ /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/cfg/user_template.cfg	(revision 8826)
@@ -19,5 +19,5 @@
 ## ---------------------
 
-## Checkout/Compilation folder ('CONFIG' root directory by default)
+## Checkout/Compilation folder ('CONFIG' root parent directory by default)
 TRUST_DIR_WORK=''
 
Index: /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/inc/trusting.env
===================================================================
--- /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/inc/trusting.env	(revision 8825)
+++ /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/inc/trusting.env	(revision 8826)
@@ -19,31 +19,4 @@
 fi
 
-## Forcing archive unset
-#if [[ ! ${TRUST_IO_FORC_TAR} && ${TRUST_IO_FORC_TAR-_} ]]; then
-
-    ## Forcing directory set
-#    if [ ${TRUST_IO_FORC_PATH} ]; then
-
-	## Default forcing archive from trunk
-#	TRUST_IO_FORC_TAR='ORCA2_LIM_nemo_v3.7.tar INPUTS_PISCES_v3.6st.tar'
-
-#	[ ${TRUST_CFG_REF} == 'AMM12' ] && TRUST_IO_FORC_TAR='AMM12_v3.7.tar'
-
-#	if [ ${TRUST_SVN_BRANCH} == 'nemo_v3_6_STABLE' ]; then
-
-#	    TRUST_IO_FORC_TAR='ORCA2_LIM_nemo_v3.6.tar'
-
-#	    if   [ ${TRUST_CFG_REF} == 'ORCA1_LIM3_PISCES' ]; then
-#		TRUST_IO_FORC_TAR='INPUTS_ORCA1_LIM3_PISCES_V10.tar'
-#	    elif [ ${TRUST_CFG_REF} == 'AMM12'             ]; then
-#		TRUST_IO_FORC_TAR='AMM12_v3.6.tar'
-#	    fi
-
-#	fi
-
-#    fi
-
-#fi
-
 
 ## Source user & (super)computer configurations
@@ -61,5 +34,4 @@
 [ -z "${TRUST_DIR_WORK}"    ] &&    TRUST_DIR_WORK=${TRUST_MAIN_DIR}/../CONFIG
 [ -z "${TRUST_DIR_SCRATCH}" ] && TRUST_DIR_SCRATCH=${TRUST_MAIN_DIR}
-
 export TRUST_DIR_WORK TRUST_DIR_SCRATCH TRUST_DIR_STORE
 
@@ -69,12 +41,13 @@
 
 export TRUST_SVN_REPO='https://forge.ipsl.jussieu.fr/nemo/svn'
-
-export TRUST_SVN_CO=( 'ARCH           CONFIG          NEMO               \
-                       EXTERNAL/AGRIF EXTERNAL/fcm    EXTERNAL/IOIPSL    \
-                       TOOLS/COMPILE  TOOLS/maketools TOOLS/REBUILD_NEMO \
-                       TRUST                                              ' )
+export TRUST_SVN_CO=( 'ARCH           CONFIG          NEMO              
+                       EXTERNAL/AGRIF EXTERNAL/fcm    EXTERNAL/IOIPSL   
+                       TOOLS/COMPILE  TOOLS/maketools TOOLS/REBUILD_NEMO
+                       TRUST                                            ' )
+export TRUST_SVN_UP=( 'ARCH           CONFIG          NEMO           
+                       EXTERNAL/AGRIF EXTERNAL/fcm    EXTERNAL/IOIPSL
+                       TOOLS/COMPILE                                 ' )
 
 export TRUST_SVN_BRANCH
-
 export TRUST_SVN_NEMOGCM=${TRUST_DIR_WORK}/${TRUST_SVN_BRANCH}/NEMOGCM
 
@@ -83,16 +56,4 @@
 ##-------------------
 
-## Ref. cfg. unset or empty (mandatory)
-#if [[ -z "${TRUST_CFG_REF}" ]]; then
-
-    ## Default cfg from trunk excepting last stable
-#    TRUST_CFG_REF='ORCA2_LIM3_PISCES'
-
-#    if [ ${TRUST_SVN_BRANCH} == 'nemo_v3_6_STABLE' ]; then
-#	TRUST_CFG_REF='ORCA2_LIM_PISCES'
-#    fi
-
-#fi
-
 ## Forcing archive unset
 if [[ ! ${TRUST_IO_FORC_TAR} && ${TRUST_IO_FORC_TAR-_} ]]; then
@@ -100,12 +61,9 @@
     ## Forcing directory set
     if [ ${TRUST_IO_FORC_PATH} ]; then
-
 	## Default forcing archive from trunk
 	TRUST_IO_FORC_TAR='ORCA2_LIM_nemo_v3.7.tar INPUTS_PISCES_v3.6st.tar'
-
 	[ ${TRUST_CFG_REF} == 'AMM12' ] && TRUST_IO_FORC_TAR='AMM12_v3.7.tar'
 
 	if [ ${TRUST_SVN_BRANCH} == 'nemo_v3_6_STABLE' ]; then
-
 	    TRUST_IO_FORC_TAR='ORCA2_LIM_nemo_v3.6.tar'
 
@@ -123,8 +81,5 @@
 
 [ -z "${TRUST_CFG_NEW}" ] && TRUST_CFG_NEW=${TRUST_CFG_REF}'_trust'
-
 export TRUST_CFG_NEW TRUST_CFG_REF
-export TRUST_IO_FORC_TAR
-
 export TRUST_CFG_KEY_ADD TRUST_CFG_KEY_DEL
 
@@ -133,6 +88,7 @@
 ## --------------
 
-[ -z "${TRUST_IO_XIOS}" ] && get_out X
-export TRUST_IO_XIOS TRUST_IO_FORC_PATH
+[ -z "${TRUST_IO_XIOS}" ] && get_out A
+export TRUST_IO_XIOS
+export TRUST_IO_FORC_PATH TRUST_IO_FORC_TAR
 export TRUST_IO_CDO
 
@@ -141,10 +97,33 @@
 ##----------------------
 
+if [ -z "${TRUST_JOB_ENV}" ]; then
+    TRUST_JOB_ENV=${TRUST_IO_XIOS}/arch/arch-${TRUST_MAIN_HPCC}.env
+fi
+
 export TRUST_JOB_ENV
-export TRUST_COMPILE_FORTRAN TRUST_COMPILE_NPROC
-export TRUST_COMPILE_MPI     TRUST_COMPILE_NETCDF
-export TRUST_JOB_SCRIPT TRUST_JOB_SUBMIT 
-export TRUST_JOB_STATE  TRUST_JOB_KILL   TRUST_JOB_TIMEOUT
-export TRUST_JOB_INFO   TRUST_JOB_TIME   TRUST_JOB_RAM_P   TRUST_JOB_RAM_V
+
+[ -z "${TRUST_COMPILE_NPROC}" ] && TRUST_COMPILE_NPROC='4'
+export TRUST_COMPILE_NPROC
+
+export TRUST_COMPILE_FORTRAN TRUST_COMPILE_MPI TRUST_COMPILE_NETCDF
+
+if [ -z "${TRUST_JOB_SCRIPT}" ]; then
+    TRUST_JOB_SCRIPT=${TRUST_MAIN_DIR}/batch/${TRUST_MAIN_HPCC}.sh || get_out A
+fi
+
+export TRUST_JOB_SCRIPT 
+
+
+if [[ -z "${TRUST_JOB_SUBMIT}" || -z "${TRUST_JOB_STATE}" \
+                               || -z "${TRUST_JOB_KILL}"    ]]; then
+    get_out A
+fi
+
+export TRUST_JOB_SUBMIT TRUST_JOB_STATE TRUST_JOB_KILL
+
+[ -z "${TRUST_JOB_TIMEOUT}" ] && TRUST_JOB_TIMEOUT='10800'
+export TRUST_JOB_TIMEOUT
+
+export TRUST_JOB_INFO TRUST_JOB_TIME TRUST_JOB_RAM_P TRUST_JOB_RAM_V
 
 
@@ -160,5 +139,6 @@
 ##       TRUST_TEST_DIR unset
 if [[ ! ${TRUST_TEST_DIR}       && ${TRUST_TEST_DIR-_}       ]]; then
-        TRUST_TEST_DIR=${TRUST_DIR_SCRATCH}/${TRUST_CFG_REF}/${TRUST_SVN_BRANCH}/${TRUST_TEST_DATE}
+        TRUST_TEST_DIR=${TRUST_DIR_SCRATCH}/${TRUST_CFG_REF}/${TRUST_SVN_BRANCH}
+        TRUST_TEST_DIR+=/${TRUST_TEST_DATE}
     export TRUST_TEST_DIR
 fi
Index: /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/inc/trusting_func.sh
===================================================================
--- /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/inc/trusting_func.sh	(revision 8825)
+++ /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/inc/trusting_func.sh	(revision 8826)
@@ -3,4 +3,6 @@
 
 ## Messenger filenames
+##--------------------------------------------------------------------------------
+
 file_date=mesg_01_date.txt  ; file_rslt=mesg_02_result.txt
 file_stat=mesg_03_status.txt; file_nemo=mesg_04_nemo.txt
@@ -12,4 +14,9 @@
 
 ## Functions in order of use
+##--------------------------------------------------------------------------------
+
+## 
+##--------------------------------------------------------------------------------
+
 print_step() {
     local char_nb=$( echo "$1" | wc -c )
@@ -18,4 +25,8 @@
     printf "\nStep.....\n%s\n%s\n" "$1" ${outline// /-}
 }
+
+
+##
+##--------------------------------------------------------------------------------
 
 init_files() {
@@ -33,5 +44,5 @@
     echo 'Comments'            > ${file_note}
 
-    ## 'Failed' status with 'Unknown error' by default
+    ## 'FAILED' status with 'Unknown error' by default
     echo ${TRUST_FLAG_RESULT} \
 	>> ${file_rslt}
@@ -40,4 +51,8 @@
 }
 
+
+##
+##--------------------------------------------------------------------------------
+
 get_date() {
     ## UTC time zone for timestamping
@@ -48,4 +63,8 @@
 }
 
+
+##
+##--------------------------------------------------------------------------------
+
 get_nemo_rev() {
     local dir rev_loc
@@ -53,5 +72,5 @@
 
     ## Loop on essential NEMO directories
-    for dir in ${TRUST_SVN_CO} ${TRUST_IO_XIOS}; do
+    for dir in ${TRUST_SVN_UP} ${TRUST_IO_XIOS}; do
 
 	## For time being, just get revision from XIOS with no action on directory
@@ -60,11 +79,11 @@
 	    echo 'XIOS '${rev_loc} \
 		>> model.log
-	    echo "<a href=\"https://forge.ipsl.jussieu.fr/ioserver/changeset/${rev_loc}\" target=\"_blank\">${rev_loc}</a>"
+	    echo "<a href=\"https://forge.ipsl.jussieu.fr/ioserver/changeset/${rev_loc}\" target=\"_blank\">${rev_loc}</a>" \
 		>> ${file_xios}
 	    continue
 	fi
 
-	echo $dir && ${TRUST_SVN_ACTION} ${TRUST_DIR_NEMOGCM}/$dir
-	rev_loc=$( svn info ${TRUST_DIR_NEMOGCM}/$dir  \
+	echo $dir && ${TRUST_SVN_ACTION} ${TRUST_SVN_NEMOGCM}/$dir || get_out C
+	rev_loc=$( svn info ${TRUST_SVN_NEMOGCM}/$dir  \
 	           | awk '/Last Changed Rev/ {print $NF}'   )
 
@@ -75,7 +94,10 @@
     echo 'NEMOGCM '$rev \
 	>> model.log
-    echo "<a href=\"https://forge.ipsl.jussieu.fr/nemo/changeset/$rev\" target=\"_blank\">$rev</a>"
+    echo "<a href=\"https://forge.ipsl.jussieu.fr/nemo/changeset/$rev\" target=\"_blank\">$rev</a>" \
 	>> ${file_nemo}
 }
+
+##
+##--------------------------------------------------------------------------------
 
 get_soft_rel() {
@@ -115,4 +137,8 @@
 	>> ${file_ncdf}
 }
+
+
+##
+##--------------------------------------------------------------------------------
 
 get_inputs() {
@@ -156,4 +182,8 @@
 }
 
+
+##
+##--------------------------------------------------------------------------------
+
 diff_inputs() {
     local dif file
@@ -192,4 +222,8 @@
 	>> temp_${file_note}
 }
+
+
+##
+##--------------------------------------------------------------------------------
 
 job_pending() {
@@ -214,8 +248,12 @@
     if [ ${time_elapsed} -eq ${TRUST_JOB_TIMEOUT} ]; then
 	eval ${TRUST_JOB_KILL} &> /dev/null
-	get_out 6
-    fi
-
-}
+	get_out I
+    fi
+
+}
+
+
+##
+##--------------------------------------------------------------------------------
 
 diff_results() {
@@ -230,5 +268,5 @@
     for file in 'ocean.output' *.stat; do
 	## Stop if no minimal benchmark files (ocean.output, eventual stat files)
-	[ ! -e ${TRUST_TEST_BENCHMARK}/$file ] && get_out 7
+	[ ! -e ${TRUST_TEST_BENCHMARK}/$file ] && get_out J
 
 	diff -q $file ${TRUST_TEST_BENCHMARK}/$file
@@ -245,4 +283,8 @@
 	>> temp_${file_note}
 }
+
+
+##
+##--------------------------------------------------------------------------------
 
 diff_restarts() {
@@ -263,11 +305,9 @@
 		       | wc -l | awk '{print $1}'              )
 
-	    [ $ndomain -eq 0 ] && get_out X
-
             #####################################################
             ## Handle 2 possibilities of 'rebuild_nemo' origin ##
             #####################################################
 
-	    ${TRUST_DIR_NEMOGCM}/TOOLS/REBUILD_NEMO/rebuild_nemo \
+	    ${TRUST_SVN_NEMOGCM}/TOOLS/REBUILD_NEMO/rebuild_nemo \
 		-t ${TRUST_COMPILE_NPROC} $filebase $ndomain       \
 		> /dev/null
@@ -278,5 +318,5 @@
                     > /dev/null
 	    else
-		get_out X
+		get_out K
 	    fi
 
@@ -314,4 +354,8 @@
 }
 
+
+##
+##--------------------------------------------------------------------------------
+
 get_time() {
     [ -z "${TRUST_JOB_TIME}" ] && return
@@ -323,4 +367,8 @@
     echo ${time_cpu} | tee -a ${file_time}
 }
+
+
+##
+##--------------------------------------------------------------------------------
 
 get_memy() {
@@ -334,4 +382,8 @@
     echo ${memory_pmax}' / '${memory_vmax} | tee -a ${file_memy}
 }
+
+
+##
+##--------------------------------------------------------------------------------
 
 comments() {
@@ -351,4 +403,8 @@
 	>> temp_${file_note} )
 }
+
+
+##
+##--------------------------------------------------------------------------------
 
 log_make() {
@@ -363,4 +419,8 @@
 }
 
+
+##
+##--------------------------------------------------------------------------------
+
 prod_publish() {
     local cmd
@@ -373,9 +433,9 @@
 	if [ -f ${TRUST_TEST_LOG} ]; then cmd='tail -1'; else cmd='cat'; fi
 
-	$cmd ${TRUST_TEST_SUMMARY}      \
+	$cmd ${TRUST_TEST_SUMMARY} \
 	    >> ${TRUST_TEST_LOG}
 
         ## Send mail only when FAILED
-	if [[ ! -z "${TRUST_TEST_MAILING}" \
+	if [[ ! -z "${TRUST_TEST_MAILING}"        \
 	      && ${TRUST_FLAG_RESULT} == 'FAILED'   ]]; then
 
@@ -412,4 +472,8 @@
 }
 
+
+##
+##--------------------------------------------------------------------------------
+
 get_out() {
     local time_step=0
@@ -427,18 +491,30 @@
         ## Error identification
 	case ${TRUST_FLAG_ERROR} in
+
+	    ## Initialisation
+	    'A') TRUST_FLAG_ERROR='Missing environment variable'      ;;
+	    'B') TRUST_FLAG_ERROR='Unable to create testing directory';;
+	    'C') TRUST_FLAG_ERROR='SVN issue on local working copy'   ;;
+
             ## Compilation
-	    '1') TRUST_FLAG_ERROR='XIOS compilation failed' ;;
-	    '2') TRUST_FLAG_ERROR='NEMO compilation failed' ;;
+	    'D') TRUST_FLAG_ERROR='XIOS compilation failed'           ;;
+	    'E') TRUST_FLAG_ERROR='NEMO compilation failed'           ;;
+
 	    ## Submission
-	    '3') TRUST_FLAG_ERROR='Missing input files'     ;;
-	    '4') TRUST_FLAG_ERROR='Job submission error'    ;;
+	    'F') TRUST_FLAG_ERROR='Missing input files'               ;;
+	    'G') TRUST_FLAG_ERROR='Job submission error'              ;;
+
 	    ## Computing
-	    '5') TRUST_FLAG_ERROR='Crashed at time step'    ;;
-	    '6') TRUST_FLAG_ERROR='Exceeded time limit'     ;;
+	    'H') TRUST_FLAG_ERROR='Crashed at time step'              ;;
+	    'I') TRUST_FLAG_ERROR='Exceeded time limit'               ;;
+
 	    ## Results
-	    '7') TRUST_FLAG_ERROR='Missing previous outputs';;
-	    '8') TRUST_FLAG_ERROR='New outputs differ'      ;;
+	    'J') TRUST_FLAG_ERROR='Missing previous outputs'          ;;
+	    'K') TRUST_FLAG_ERROR='Restart rebuild error'             ;;
+	    'L') TRUST_FLAG_ERROR='New outputs differ'                ;;
+
 	    ## Other
-	    '*') TRUST_FLAG_ERROR='Unknown error'           ;;
+	    '*') TRUST_FLAG_ERROR='Unknown error'                     ;;
+
 	esac
 
@@ -448,5 +524,5 @@
 
     ## Eventual comments from ocean.output
-    if [ "${TRUST_FLAG_ERROR}" == 'Crashed at time step' ]; then
+    if [ ${TRUST_FLAG_ERROR} == 'Crashed at time step' ]; then
 	comments 'E R R O R'
 	[ -e time.step ] && time_step=$( cat time.step )
@@ -455,5 +531,5 @@
 	comments 'W A R N I N G'
 
-	if [ "${TRUST_FLAG_ERROR}" == 'Exceeded time limit' ]; then
+	if [ ${TRUST_FLAG_ERROR} == 'Exceeded time limit' ]; then
 	    TRUST_FLAG_ERROR+=' '$(( ${TRUST_JOB_TIMEOUT}/3600 ))'h'
 	fi
@@ -462,6 +538,6 @@
 
     ## Last messenger files
-    sed -i "2 s/.*/$TRUST_RESULT/"     ${file_rslt}
-    sed -i "2 s/.*/$TRUST_FLAG_ERROR/" ${file_stat}
+    sed -i "2 s/.*/$TRUST_FLAG_RESULT=/" ${file_rslt}
+    sed -i "2 s/.*/$TRUST_FLAG_ERROR/"   ${file_stat}
 
     ## Save tested configuration if trusting failed in production mode (-p|--prod)
@@ -469,6 +545,6 @@
 	echo 'Creating archive '${TRUST_TEST_BACKUP}' under '${TRUST_TEST_BENCHMARK}
 	tar -czf ${TRUST_TEST_BENCHMARK}/${TRUST_TEST_BACKUP}                 * \
-	    -C   ${TRUST_DIR_NEMOGCM}/CONFIG/${TRUST_CFG_NEW}/MY_SRC . \
-	    -C   ${TRUST_DIR_NEMOGCM}/CONFIG/${TRUST_CFG_NEW}          \
+	    -C   ${TRUST_SVN_NEMOGCM}/CONFIG/${TRUST_CFG_NEW}/MY_SRC . \
+	    -C   ${TRUST_SVN_NEMOGCM}/CONFIG/${TRUST_CFG_NEW}          \
 	         cpp_${TRUST_CFG_NEW}.fcm
     fi
Index: /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/trusting.sh
===================================================================
--- /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/trusting.sh	(revision 8825)
+++ /branches/2015/dev_r5092_CNRS18_TRUST/NEMOGCM/TRUST/trusting.sh	(revision 8826)
@@ -103,5 +103,5 @@
 print_step 'Timestamped testing directory'
 
-mkdir -p ${TRUST_TEST_DIR} ${TRUST_TEST_BENCHMARK}
+mkdir -p ${TRUST_TEST_DIR} ${TRUST_TEST_BENCHMARK} || get_out B
 cd       ${TRUST_TEST_DIR}
 echo     ${TRUST_TEST_DIR}
@@ -123,5 +123,5 @@
 ##--------------------------------------------------------------------------------
 
-print_step 'Get testing environement'
+print_step 'Get testing environment'
 
 get_soft_rel
@@ -141,5 +141,5 @@
     ${stdout_redir} /dev/null
 
-[ ! -e lib/libxios.a ] && get_out 1 || echo 'Success'
+[ ! -e lib/libxios.a ] && get_out D || echo 'Success'
 
 
@@ -163,5 +163,5 @@
     ${stdout_redir} /dev/null
 
-[ ! -e ${TRUST_CFG_NEW}/BLD/bin/nemo.exe ] && get_out 2 || echo 'Success'
+[ ! -e ${TRUST_CFG_NEW}/BLD/bin/nemo.exe ] && get_out E || echo 'Success'
 
 
@@ -198,5 +198,5 @@
 TRUST_JOB_ID=$( eval ${TRUST_JOB_SUBMIT} )
 
-[ $? -ne 0 ] && get_out 4 || printf "Success (job ID %s)\n" ${TRUST_JOB_ID}
+[ $? -ne 0 ] && get_out G || printf "Success (job ID %s)\n" ${TRUST_JOB_ID}
 
 print_step 'Pending job'
@@ -213,5 +213,5 @@
 
 if [[ ! -e time.step || $( grep 'E R R O R' ocean.output ) ]]; then
-    get_out 5
+    get_out H
 else
     echo 'Success' ## Must be reviewed
@@ -238,5 +238,5 @@
 diff_restarts
 
-[ $TRUST_RESULT == 'FAILED' ] && get_out 8
+[ $TRUST_FLAG_RESULT= == 'FAILED' ] && get_out L
 
 